package com.s477603.movies.dto;

import com.s477603.movies.document.Movie;
import com.s477603.movies.document.User;
import lombok.Builder;
import lombok.Data;

@Builder
@Data
public class WatchlistRecordDTO {
    private Integer movieId;
    private String title;
    private String posterPath;
    private String userId;
    private Boolean watched;

    public static WatchlistRecordDTO from(Movie movie, User user) {
        return WatchlistRecordDTO.builder()
                .movieId(movie.getId())
                .title(movie.getTitle())
                .posterPath(movie.getPoster_path())
                .userId(user.getId())
                .build();
    }
}
