package com.s477603.movies.repository;

import com.s477603.movies.document.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public class UserRepository {

    @Autowired
    JdbcTemplate jdbcTemplate;

    public void save(User user) {
        jdbcTemplate.update("INSERT INTO users (username, password, id) VALUES (?, ?, ?)",
                user.getUsername(), user.getPassword(), user.getId());
    }

    public Optional<User> findByUsername(String username) {
        return Optional.ofNullable(jdbcTemplate.queryForObject("SELECT * FROM users WHERE username = ?",
                BeanPropertyRowMapper.newInstance(User.class), username));
    }

    public Optional<User> findById(String id) {
        return Optional.ofNullable(jdbcTemplate.queryForObject("SELECT * FROM users WHERE id = ?",
                BeanPropertyRowMapper.newInstance(User.class), id));
    }

    public boolean existsByUsername(String username) {
        return jdbcTemplate.queryForObject("SELECT EXISTS(SELECT 1 FROM users WHERE username = ?)",
                Boolean.class, username);
    }
}
